import numpy as np
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
from matplotlib.colors import ListedColormap

D = np.loadtxt( 'datos.txt' )

X = D[:,0:2]
y = D[:,2]

# Se separan los datos en datos de entrenamiento
# y datos de prueba

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=2 )

# Las clases [0. 1. 2.]

V = np.array( [[-0.61856916, -0.79241176],
               [ 1.31670781, -0.44554503],
               [-0.69813865,  1.23795679]] )

A0 = np.array( [[0.12430938,  0.2410679,  -0.36537728]] )

n, m = X_prueba.shape

def funcion_de_decision( vx ) :
	vr = np.dot( V, vx.T ) + A0
	#           3x2 2x1 = 3x1 
	# El valor máximo de correponde a la máxima probabilidad
	# y no calculamos la sigmoide
	k = np.argmax( vr )
	return k

n = 100
vx = np.linspace( -5, 4, n )
vy = np.linspace( -6, 6, n )

x, y = np.meshgrid( vx, vy )
Z = np.zeros( (n,n) )

va = np.zeros( (1,2) )

for i in range(n):
    for j in range(n):
        va[0,0]  = x[j,i]
        va[0,1]  = y[j,i]
        Z[j,i] = funcion_de_decision( va )


fig, [ax1, ax2] = plt.subplots( nrows=1, ncols=2 )

ax1.set_xlim( -5, 4)
ax1.set_ylim( -6, 6)
cm = plt.cm.RdBu
cm_bright = ListedColormap(['#FF0000', '#0000FF'])
ax1.contourf( x, y, Z, cmap=cm, alpha=.8 )
ax1.scatter( X_entrena[:,0], X_entrena[:,1], c=y_entrena )

ax2.set_xlim( -5, 4)
ax2.set_ylim( -6, 6)
ax2.contourf( x, y, Z, cmap=cm, alpha=.8 )
ax2.scatter( X_prueba[:,0], X_prueba[:,1], c=y_prueba )

plt.show( )
