import numpy as np
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import train_test_split



D = np.loadtxt( 'datos.txt' )

X = D[:,0:2]
y = D[:,2]

# Se separan los datos en datos de entrenamiento
# y datos de prueba

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=2 )

clasificador = LogisticRegression( )

clasificador.fit( X_entrena, y_entrena )

exactitud = clasificador.score( X_prueba, y_prueba )
print( exactitud )

print( clasificador.classes_ )
#  ndarray of shape (n_classes, )

print( clasificador.coef_ )
#  : ndarray of shape (1, n_features) or (n_classes, n_features)

print( clasificador.intercept_ )
#  : ndarray of shape (1,) or (n_classes,)

